*-------------------------------------------------------------------------------*
*-- Codigo original Walter TAVERNA        de San Francisco, Crdoba, Argentina. *
*-- Codigo Impresion Chelo Pcia.          de Buenos Aires,  Argentina.          * 
*-- Modificado y Adaptado Mustafa Lpez   de Alicante,  Espaa 2010             *
*-- Function Original "RTF" brunellopulix (brunellopulix@yahoo.it)              *
*-------------------------------------------------------------------------------*
 
 #include "hmg.ch"     
 #include "BoxLetterShoW.ch"
 #include "Cod_paisx.prg"
 #include "Impresion.prg"
 #include "basJOIN1.prg"
 #include "basJOIN2.prg"
 #include "Basex2.prg"
 #include "Basex3.prg"
 #include "hbcodebar.prg"
 #include "hbqcell.prg"
 #include "HBXRTF.prg"


 FUNCTION main()

*----------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*----------------------------------------*

 SET CODEPAGE TO SPANISH 

 REQUEST DBFCDX , DBFFPT
 RDDSETDEFAULT( 'DBFCDX' )

*---------------------------------*
  ERASE("COD_PRO.CDX")
  ERASE("COD_STO.CDX")      
  ERASE("NOM_PAIS.CDX")   
  ERASE("NUM_PAIS.CDX")   
*---------------------------------*
  IF .NOT. FILE('COD_PRO.CDX') 
     USE COD_PRO New 
     INDEX on numer to COD_PRO 
     COD_PRO->( DBCLOSEAREA() )
  ENDIF

  IF .NOT. FILE('COD_STO.CDX') 
     USE COD_STO New
     INDEX on numero to COD_STO  
     COD_STO->( DBCLOSEAREA() )
  ENDIF

  IF .NOT. FILE('NOM_PAIS.CDX') 
     USE COD_PAIS New 
     INDEX on PAIS to NOM_PAIS
     COD_PAIS->( DBCLOSEAREA() ) 
  ENDIF

  IF .NOT. FILE('NUM_PAIS.CDX') 
     USE COD_PAIS New 
     INDEX on COD_PAIS to NUM_PAIS
     COD_PAIS->( DBCLOSEAREA() ) 
  ENDIF
*---------------------------------------*
 SET DATE FRENCH
 SET CENTURY ON
 SET DELETED ON
 SET ESCAPE ON
 SET NAVIGATION EXTENDED
 SET SOFTSEEK ON 
 SET BROWSESYNC ON
*---------------------------------------* 
 SET TOOLTIPSTYLE BALLOON
// this follow rows is required ONLY for HMG Minigui compatibility
#ifdef __MINGW32__
  SET TOOLTIPBACKCOLOR { 255,255,184 }
  SET TOOLTIPFORECOLOR { 000,000,000 }
#endif

*------------------------------------------------------------------------------------------------------------*

   PRIVATE  cDescEfeito , proA , artI , Buscar , BuscarX , Canti , CanTot , Respal, Nomix , aChecbo 
   PRIVATE  tcString ,lcRet, lnI, lnCheckSum, lnAux , New , PasNew , CoPais , NomPais , RTFmirax ,   RTFmiraz 

   PRIVATE  Cnumero  , Tab1CodBar  , LitCD  , HH  , LetraTabla
   PRIVATE  CnumeroX , Tab1CodBarX , LitCDX , HHX , LetraTablaX

*------------------------------------------------------------------------------------------------------------* 

   Respal:="[ Esc] = Salir"+ SPACE(45)+"Gestin Almacen"+SPACE(25) + "F2 -> Cosulta Paises"

  DEFINE WINDOW barcode  ;
             AT 000 , 000    ;
             WIDTH 850       ;
             HEIGHT 700      ;
             TITLE Respal    ; 
             ICON 'Logo.ico'          ;
             BACKCOLOR { 117,117,255 };    
             MAIN NOSIZE  NOMAXIMIZE  ;
             ON INIT OpenTables()     ;   
             ON RELEASE CloseTables()  
             ON KEY F2 ACTION COD_PAISX() 
             ON KEY ESCAPE ACTION barcode.Release  

*-------------------------------------------------- Ttulo -------------------------------------------*
 
     LabelBox(028, 230, 500, 030 ,"001a","Entrada Artculos Almacen",23 ,.T.,.T., , , , , , ) 

*-----------------------------------------------------------------------------------------------------* 

*-------------------------------  Entrada codigo de Barras  EAN13 - EAN08 ----------------------------*

      DEFINE TEXTBOX Text_1
         ROW 085
         COL 110
         WIDTH 108
         VALUE NIL
         HEIGHT 024
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP "Lea Cdigo de Barras"
         ONCHANGE ( if( len( barcode.Text_1.value ) = 13, ( barcode.Tet_04.setfocus), .t. ) , (BarEAN13(barcode.Text_1.Value) , barcode.Label_3.Refresh ) )  
         ONGOTFOCUS NIL  
         ONLOSTFOCUS Nil
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         ONENTER Nil
         HELPID Nil
         TABSTOP .T.
         VISIBLE .T.
         READONLY .F.
         RIGHTALIGN .F.
         BACKCOLOR { 255,185,220 } 
         FONTCOLOR Nil
         MAXLENGTH 13
         FORMAT Nil 
      END TEXTBOX

      DEFINE TEXTBOX Text_1X
         ROW 085
         COL 110
         WIDTH 108
         VALUE NIL
         HEIGHT 024
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP "Lea Cdigo de Barras"
         ONCHANGE( if( len( barcode.Text_1X.value ) = 8, ( barcode.Tet_04.setfocus), .t. ) , (BarEAN08(barcode.Text_1X.Value) , barcode.Label_3.Refresh ) )     
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         ONENTER Nil
         HELPID Nil
         TABSTOP .T.
         VISIBLE .T.
         READONLY .F.
         RIGHTALIGN .F.
         BACKCOLOR { 255,185,220 } 
         FONTCOLOR Nil 
         MAXLENGTH 8
         FORMAT Nil 
      END TEXTBOX

*----------X--------- Invisible --------X--------*
   @ 123,130 TEXTBOX Tet_01 ;
   FIELD COD_PAIS->COD_PAIS ;
   WIDTH 100 HEIGHT 020 ;
   NUMERIC ;
   TOOLTIP ''

  @ 163,130 TEXTBOX Tet_02 ;
   FIELD COD_PAIS->PAIS ;
   WIDTH 100 HEIGHT 020 ;
   MAXLENGTH 025 ;
   TOOLTIP ''
*----------X--------- Invisible -------X---------*

*-----------------------------------------------------------------------------------------------------* 
 
   LabelBox(086, 050, 040, 024 ,"1","Code:",9 ,.T.,.T., , , , , , )   //  Label_1

*-----------------------------------------------------------------------------------------------------* 
 
   @ 089,275 LABEL Label_2a VALUE " EAN-13" WIDTH 150 HEIGHT 028 TOOLTIP "EAN-13" FONT "Arial" SIZE 9 BOLD ITALIC BACKCOLOR { 117,117,255 }    
   
      
   @ 089,275 LABEL Label_1a VALUE " EAN-8 " WIDTH 150 HEIGHT 028 TOOLTIP "EAN-8" FONT "Arial" SIZE 9 BOLD ITALIC BACKCOLOR { 117,117,255 }   
 
        
   barcode.Label_1a.HIDE
    
   
      DEFINE CHECKBOX Check_1
        ROW    083
        COL    256
        WIDTH  020  
        HEIGHT 028
        CAPTION ""  
        VALUE .T.               
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "EAN-13 ? / EAN-8 ?"
        ONCHANGE CambiaX()                        
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        BACKCOLOR { 117,117,255 }  
        FONTCOLOR Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.
     END CHECKBOX

*---------------------------------------------------------------------------*

      @ 085,490 TEXTBOX Tet_04 ;
         WIDTH 225 HEIGHT 024 ;
         TOOLTIP 'Proveedor';
         VALUE '' ;
         BACKCOLOR {  255,185,220 } 

*----------------------------------------------------------------------------*

     LabelBox(086, 400, 090, 024 ,"104","Proveedor:",9 ,.T.,.T., , , , , ,  )   //  Label_104

*----------------------------------------------------------------------------*

      @ 125,490 TEXTBOX Tet_05 ;
         WIDTH 225 HEIGHT 024 ;
         TOOLTIP 'Artculo';
         VALUE '' ;
         BACKCOLOR {  255,185,220 } 
*----------------------------------------------------------------------------*

     LabelBox(126, 400, 090, 024 ,"105","Artculo:",9 ,.T.,.T., , , , , ,  )   //  Label_105

*----------------------------------------------------------------------------*

*----------------------------------------------------------------------------*
         
      DEFINE TEXTBOX Tet_06
         ROW 165
         COL 490
         WIDTH 070
         VALUE 0
         HEIGHT 24
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP "Cantidad"
         ONCHANGE Nil
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         ONENTER Nil
         HELPID Nil
         TABSTOP .T.
         VISIBLE .T.
         READONLY .F.
         RIGHTALIGN .F.
         BACKCOLOR { 255,185,220 } 
         FONTCOLOR Nil
         INPUTMASK "99999999"  
         FORMAT Nil
      END TEXTBOX 

*--------------------------------------------------------------------------*

     LabelBox(166, 400, 090, 024 ,"106","Cantidad:",9 ,.T.,.T., , , , , ,  )   //  Label_106

*--------------------------------------------------------------------------*

*--------------------------------------------------------------------------*

     LabelBox(206, 400, 040, 024 ,"107","Fecha:",9 ,.T.,.T., , , , , ,  )      //  Label_107

*--------------------------------------------------------------------------*

      DEFINE TEXTBOX Tet_07
         ROW 205
         COL 490
         WIDTH 075
         VALUE DTOC(DATE())
         HEIGHT 24
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP "Fecha Entrada"
         ONCHANGE Nil
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         ONENTER Nil
         HELPID Nil
         TABSTOP .T.
         VISIBLE .T.
         READONLY .F.
         RIGHTALIGN .F.
         BACKCOLOR { 255,185,220 } 
         FONTCOLOR Nil
         INPUTMASK "99/99/9999"  
         FORMAT Nil
      END TEXTBOX
 
 *---------------------- Representacin Dibujo Cdigo de Barras ----------------------------*      

   aChecbo  := ( IIF(barcode.Check_1.Value,"True","False") )
 
   IF aChecbo = "False" 
   
       DEFINE LABEL Label_3          // <---------  Representacin Dibujo CodeBar
          ROW    165       
          COL    300              
          WIDTH  220    
          HEIGHT 095    
          VALUE NIL
          FONTNAME "CODE EAN13"
          FONTSIZE 50
          TOOLTIP ""
          FONTBOLD .F.
          FONTITALIC .F.
          FONTUNDERLINE .F.
          FONTSTRIKEOUT .F.
          HELPID Nil
          VISIBLE .T.
          TRANSPARENT .F.
          ACTION Nil
          AUTOSIZE .F.
          BACKCOLOR {155,197,229}                
          FONTCOLOR {000,000,000}   
       END LABEL 

   ELSE
 
       DEFINE LABEL Label_3          // <---------  Representacin Dibujo CodeBar
          ROW    165      
          COL    095           
          WIDTH  220    
          HEIGHT 095    
          VALUE NIL
          FONTNAME "CODE EAN13"
          FONTSIZE 50
          TOOLTIP ""
          FONTBOLD .F.
          FONTITALIC .F.
          FONTUNDERLINE .F.
          FONTSTRIKEOUT .F.
          HELPID Nil
          VISIBLE .T.
          TRANSPARENT .F.
          ACTION Nil
          AUTOSIZE .F.
          BACKCOLOR {155,197,229}                
          FONTCOLOR {000,000,000}   
       END LABEL 

   ENDIF

*------------------------------------  Cuadro con Sombra ------------------------------------------*

   BoxShadow( 137,035, 310, 164 ,"11" ,"12", 155,197,229 )          

         barcode.Label_11.Enabled := .T.    // <---- Necesario si ponemos BUTTON  TEXTBOX
         barcode.Label_12.Enabled := .T.    // <---- Necessary if we BUTTON or TEXTBOX

*--------------------------------------------------------------------------------------------------*

*  Color de Fondo de Window ------->  color crema  {239,235,222}   ( Obcional )  

*--------------------------------------------------------------------------------------------------*
 
   DEFINE BUTTON Button_1
         ROW 280
         COL 490   
         WIDTH 100
         HEIGHT 28
         CAPTION "Alta"
         ACTION EAN13_EAN8()          
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP "Alta Proveedores / Articulos"
         FONTBOLD .T.
         FONTITALIC .T.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         HELPID Nil
         FLAT .F.
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
         PICTURE Nil
      END BUTTON

      DEFINE BUTTON Button_2
         ROW 280
         COL 608  
         WIDTH 100
         HEIGHT 28
         CAPTION "Borar"
         ACTION EraserEAN13EAN8()           
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP "Borrar o Modificar"
         FONTBOLD .T.
         FONTITALIC .T.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         HELPID Nil
         FLAT .F.
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
         PICTURE Nil
      END BUTTON

      DEFINE BUTTON Button_3
         ROW 280
         COL 725  
         WIDTH 100
         HEIGHT 28
         CAPTION "Salir"
         ACTION FinalProgram()      
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP "Salir del Programa"
         FONTBOLD .T.
         FONTITALIC .T.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         HELPID Nil
         FLAT .F.
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
         PICTURE Nil
      END BUTTON

      DEFINE BUTTON Button_4           
         ROW    165
         COL    685
         WIDTH  140
         HEIGHT 028
         ACTION CheckDigitEan13(tcString)    
         CAPTION "Validar EAN-13"  
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP "Validar Codigo Control EAN-13" 
         FONTBOLD .T.
         FONTITALIC .T.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         HELPID Nil
         FLAT .F.
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
         MULTILINE .F.
         PICTURE "Resource\Imag13.bmp"                   
         PICTALIGNMENT LEFT
      END BUTTON  

      DEFINE BUTTON Button_8
         ROW 205
         COL 685
         WIDTH 140
         HEIGHT 28
         CAPTION "Validar EAN-8"
         ACTION _StrToEan8(tcString,.F.)     
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP "Validar Codigo Control EAN-8"
         FONTBOLD .T.
         FONTITALIC .T.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         HELPID Nil
         FLAT .F.
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
         PICTURE "Resource\Imag08.bmp"                   
         PICTALIGNMENT LEFT 
     END BUTTON

      
      DEFINE BUTTON Button_49      
         ROW 240
         COL 490   
         WIDTH 100              
         HEIGHT 28
         CAPTION "Cd. Barras" 
         ACTION Test_Rtf1()                       
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP "Crear Fichero RTF de Codigo Barras"
         FONTBOLD .T.
         FONTITALIC .T.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         HELPID Nil
         FLAT .F.
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
         PICTURE Nil
     END BUTTON

     DEFINE BUTTON Button_50      
         ROW 240
         COL 608                 
         WIDTH 100
         HEIGHT 28
         CAPTION "Productos" 
         ACTION basJOIN1()                     
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP "Crear Fichero RTF de Productos"
         FONTBOLD .T.
         FONTITALIC .T.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         HELPID Nil
         FLAT .F.
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
         PICTURE Nil
    END BUTTON  

    DEFINE BUTTON Button_51     
         ROW 240
         COL 725             
         WIDTH 100
         HEIGHT 28
         CAPTION "Proveedores" 
         ACTION basJOIN2()                     
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP "Crear Fichero RTF de Proveedores"
         FONTBOLD .T.
         FONTITALIC .T.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         HELPID Nil
         FLAT .F.
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
         PICTURE Nil
     END BUTTON  
       
*----------------------------------------------------*

     DEFINE BUTTON BImprime
         ROW 165                    
         COL 575                      
         WIDTH 100
         HEIGHT 28
         CAPTION "Imprimir"
         ACTION ImpBarras()
         FONTNAME "Arial"
         FONTSIZE 9
         TOOLTIP "Imprimir Codigo Barras"
         FONTBOLD .T.
         FONTITALIC .T.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         HELPID Nil
         FLAT .F.
         TABSTOP .T.
         VISIBLE .T.
         TRANSPARENT .F.
         PICTURE Nil
      END BUTTON

*--------------------------------------------------------------------------------*

      LabelBox(335,120,200,024 ,"201","Proveedores:    ",14 ,.T.,.T., , , , , ,  )    //  Label_201
   
*--------------------------------------------------------------------------------*
   
*--------------------------------------------------------------------------------*

      LabelBox(335,480,350,024 ,"202","Tabla Artculos:",14 ,.T.,.T., , , , , ,  )    //  Label_202
   
*--------------------------------------------------------------------------------*

      BoxShadow(380, 020, 810, 255 ,"08qa" ,"09qa", 251 , 134 ,002 )

                     barcode.Label_08qa.Enabled  := .F.    // <---- Necessary with Textbox (write)  
                     barcode.Label_09qa.Enabled  := .F.    // <---- Necessary with Textbox (write)  

*---------------------------------------------------------------------------------*
*---------------------------------------------------------------------------------*
*---------------------------------------------------------------------------------* 

*-------------- Letra y Color ----------*
   PRIVATE cFont     := 'Arial'
   PRIVATE cSize     :=  9
   PRIVATE cFontColr := { 000,000,107}
   PRIVATE cBackColr := { 209,238,238 }  
*---------------------------------------*
    Private fColor := { || IF ( recno()/2 == int(recno()/2) , { 000,255,020 } , { 015,000,255 } ) }  
    Private bColor := { || IIF( This.CellRowIndex / 2 == INT( This.CellRowIndex / 2 ), { 255, 202, 149 } , { 080, 240, 006 } ) } 

      SELECT 1 
      USE COD_PRO INDEX COD_PRO  
      DbGoTop()   

      DEFINE BROWSE Brows_1
        ROW    390
        COL    030
        WIDTH  275
        HEIGHT 225
        VALUE NIL
        WIDTHS { 042,054,100,070 }   
        HEADERS {'Cod_Pais','Nmero','R_Social','Pais_Fabricante'}
        WORKAREA COD_PRO
        FIELDS {'COD_PAIS','NUMER','R_SOCIAL','PAIS'}
        FONTNAME cFont                  
        FONTSIZE cSize                  
        TOOLTIP ""
        ONCHANGE Nil             
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONDBLCLICK Nil
        ALLOWEDIT .T.                 
        ALLOWAPPEND .T.               
        ONHEADCLICK Nil
        ALLOWDELETE .T.                  
        HELPID Nil
        VALID Nil
        VALIDMESSAGES Nil
        LOCK .T.                          
        VSCROLLBAR .T.
        DYNAMICFORECOLOR { fcolor, fcolor, fcolor, fcolor }  
        DYNAMICBACKCOLOR { bColor, bColor, bColor, bColor }  
        INPUTMASK Nil
        FORMAT Nil
        WHEN Nil
        BACKCOLOR cBackColr               
        FONTCOLOR cFontColr  
        IMAGE Nil
        JUSTIFY { BROWSE_JTFY_RIGHT,BROWSE_JTFY_RIGHT,BROWSE_JTFY_LEFT,BROWSE_JTFY_LEFT }
        NOLINES .F.
        READONLYFIELDS Nil
      END BROWSE

      SELECT 2 
      USE COD_STO INDEX COD_STO  
      DbGoTop()  

      DEFINE BROWSE Brows_2
        ROW    390
        COL    315
        WIDTH  500
        HEIGHT 225
        VALUE NIL  //1
        WIDTHS {25,070,065,140,140,070,070,070,075,075,120}   
        HEADERS {'C','Cod_Pais','Nmero','Nom_Producto','Pais_Fabricante','Precio_C','Precio_V','Cantidad','Fecha_E','Fecha_S','COD_EAN'}
        WORKAREA COD_STO
        FIELDS  {'C','COD_PAIS','NUMERO','NOMBRE','PAIS','PRECIO_C','PRECIO_V','CANTIDAD','FECHA_E','FECHA_S','COD_EAN'}
        FONTNAME cFont                  
        FONTSIZE cSize                  
        TOOLTIP ""
        IMAGE {"br_no","br_ok"}
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .T.
        FONTITALIC .T.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONDBLCLICK Nil
        ALLOWEDIT .T.                 
        ALLOWAPPEND .T.               
        ONHEADCLICK Nil
        ALLOWDELETE .T.                  
        HELPID Nil
        VALID Nil
        VALIDMESSAGES Nil
        LOCK .T.                          
        VSCROLLBAR .T.
        DYNAMICFORECOLOR { fcolor, fcolor, fcolor, fcolor,fcolor, fcolor, fcolor, fcolor ,fcolor, fcolor, fcolor }  
        DYNAMICBACKCOLOR { bColor, bColor, bColor, bColor,bColor, bColor, bColor, bColor ,bColor, bColor, bColor }  
        INPUTMASK Nil
        FORMAT Nil
        WHEN Nil
        BACKCOLOR cBackColr               
        FONTCOLOR cFontColr               
        JUSTIFY { BROWSE_JTFY_LEFT,BROWSE_JTFY_RIGHT,BROWSE_JTFY_RIGHT,BROWSE_JTFY_LEFT,BROWSE_JTFY_LEFT,BROWSE_JTFY_RIGHT,BROWSE_JTFY_RIGHT,BROWSE_JTFY_RIGHT,BROWSE_JTFY_RIGHT,BROWSE_JTFY_LEFT }
        NOLINES .F.  
        READONLYFIELDS Nil
      END BROWSE
 
 
   END WINDOW

  
   barcode.Text_1.SetFocus
   barcode.Tet_01.VISIBLE := .F.
   barcode.Tet_02.VISIBLE := .F.  

   barcode.Button_4.Enabled := .T. 
   barcode.Button_8.Enabled := .F.  

   barcode.Brows_1.value := Recno()
   barcode.Brows_2.value := Recno()


    CENTER WINDOW barcode
    ACTIVATE WINDOW barcode

   RETURN

*-----------------------------
Procedure BarEAN13(Cnumero)
*-----------------------------
 
Declare Tab1CodBar[10]
Tab1CodBar[ 1] := "-AAAAAA"
Tab1CodBar[ 2] := "-AABABB"
Tab1CodBar[ 3] := "-AABBAB"
Tab1CodBar[ 4] := "-AABBBA"
Tab1CodBar[ 5] := "-ABAABB"
Tab1CodBar[ 6] := "-ABBAAB"
Tab1CodBar[ 7] := "-ABBBAA"
Tab1CodBar[ 8] := "-ABABAB"
Tab1CodBar[ 9] := "-ABABBA"
Tab1CodBar[10] := "-ABBABA"
LitCD          := ""


** Primer dgito
LitCD := left(Cnumero,1)

** Dgitos del 2 al 7
For HH = 2 to 7
   LetraTabla := substr(Tab1CodBar[val(left(Cnumero,1))+1],HH,1)
   if LetraTabla = "A"
      LitCD += chr( 65 + val(substr(Cnumero,HH,1)) )
   else // "B"
      LitCD += chr( 75 + val(substr(Cnumero,HH,1)) )
   endif
Next 

LitCD += "*"

** Dgitos del 8 al 13
For HH = 8 to 13
   LitCD += chr( 97 + val(substr(Cnumero,HH,1)) )
Next

LitCD += "+"

barcode.Label_3.Value := " "     
barcode.Label_3.Value := LitCD
barcode.Label_3.refresh 


Return

*-----------------------------
Procedure BarEAN08(CnumeroX)
*-----------------------------

CnumeroX := '*' + CnumeroX

Declare Tab1CodBarX[10]
Tab1CodBarX[ 1] := "-AAAAAA"
Tab1CodBarX[ 2] := "-AABABB"
Tab1CodBarX[ 3] := "-AABBAB"
Tab1CodBarX[ 4] := "-AABBBA"
Tab1CodBarX[ 5] := "-ABAABB"
Tab1CodBarX[ 6] := "-ABBAAB"
Tab1CodBarX[ 7] := "-ABBBAA"
Tab1CodBarX[ 8] := "-ABABAB"
Tab1CodBarX[ 9] := "-ABABBA"
Tab1CodBarX[10] := "-ABBABA"
LitCDX          := ""


** Primer dgito
LitCDX := left(CnumeroX,1)

** Dgitos del 2 al 5

For HHX = 2 to 5
   LetraTablaX := substr(Tab1CodBarX[val(left(CnumeroX,1))+1],HHX,1)
   if LetraTablaX = "A"
      LitCDX += chr( 65 + val(substr(CnumeroX,HHX,1)) )
   else // "B"
      LitCDX += chr( 75 + val(substr(CnumeroX,HHX,1)) )
   endif
Next 

LitCDX += "*"

** Dgitos del 6 al 6
       For HHX = 6 to 9  
      LitCDX += chr( 97 + val(substr(CnumeroX,HHX,1)) )
     Next

  LitCDX += "+"

  barcode.Label_3.Value := " "      
  barcode.Label_3.Value := LitCDX
  barcode.Label_3.refresh 

Return

*--------------------------------
 PROCEDURE CambiaX()
*---------------------------------*

   aChecbo  := ( IIF(barcode.Check_1.Value,"True","False") )
 
   IF aChecbo = "False" 
     
       barcode.Label_2a.Hide
       barcode.Label_1a.Show

       barcode.Label_3.value    := " " 
       barcode.Label_3.Refresh 
       barcode.Text_1.value     := " "
       barcode.Text_1.VISIBLE   := .F.
       barcode.Text_1X.visible  := .T.
       barcode.Button_4.Enabled := .F. 
       barcode.Button_8.Enabled := .T.  
     ELSE
       
       barcode.Label_1a.Hide
       barcode.Label_2a.Show

       barcode.Label_3.value    := " " 
       barcode.Label_3.Refresh 
       barcode.Text_1X.value    := " " 
       barcode.Text_1.visible   := .T. 
       barcode.Text_1X.visible  := .F.
       barcode.Button_4.Enabled := .T. 
       barcode.Button_8.Enabled := .F.   
   ENDIF

RETURN NIL

*---------------------------------*
 PROCEDURE FinalProgram
*---------------------------------*

 IF MsgYesNo("Desea Finalizar Programa ?","ATENCION !!!") = .T.
    barcode.Release
    Return .T.
 EndIf

*---------------------------------*
 Function OpenTables()
*---------------------------------*
 CLOSE DATABASES
 SELECT 1 
 USE COD_PRO INDEX COD_PRO         
 PACK
 SELECT 2 
 USE COD_STO INDEX COD_STO         
 PACK
 SELECT 3 
 USE COD_PAIS INDEX NUM_PAIS        
 PACK
 RETURN NIL

*---------------------------------*
 Function CloseTables()
*---------------------------------*
 CLOSE DATABASES

 RETURN NIL

*---------------------------------*
 FUNCTION CodiGus13()
*---------------------------------*

   AddFont( "Letter\PF_I2OF5.TTF" )
   
   RemoveFont("Letter\PF_I2OF5.TTF")
 
   barcode.Label_3.Refresh  
  
   cDescEfeito := barcode.Text_1.value  

  RETURN NIL


*---------------------------------*
 FUNCTION CodiGus08()
*---------------------------------*

   AddFont( "Letter\PF_I2OF5.TTF" )
 
   RemoveFont("PF_I2OF5.TTF")
 
*----------------Visor del Nmero de Barras---------------*    

   barcode.Label_3.Refresh  
  
   cDescEfeito := barcode.Text_1X.value  
    
 RETURN NIL
*---------------------------------------------------------*
 Function Test_Rtf1()       // <------ Crear Fichero  RTF
*---------------------------------------------------------*

   RTFmirax := ALLTRIM(barcode.Text_1.value) 
   RTFmiraz := ALLTRIM(barcode.Text_1x.value) 

   aChecbo  := ( IIF(barcode.Check_1.Value,"True","False") )

   IF aChecbo = "True"
      barcode.Check_1.CAPTION:= "EAN-13 ?" 

     lcRet = RTFmirax 
   
    IF LEN(lcRet) # 13
       MsgStop('Cod:'+SPACE(1)+ALLTRIM(barcode.Text_1.value)+CRLF ; 
              +'Faltan n en el Cdigo','Error Cdigo EAN-13')  
              RETURN NIL 
     ELSE
       barcode.Button_4.Enabled := .T. 
       barcode.Button_8.Enabled := .F.  
       CodiGus13()   
       RTFEAN13() 
    ENDIF
   ENDIF

   IF aChecbo = "False"
      barcode.Check_1.CAPTION := "EAN-08 ?" 
  
     lcRet = RTFmiraz  
  
     IF LEN(lcRet) # 8
        MsgStop('Cod:'+SPACE(1)+ALLTRIM(barcode.Text_1X.value)+CRLF ; 
              +'Faltan n en el Cdigo','Error Cdigo EAN-8')  
       RETURN NIL 
     ELSE
       barcode.Button_4.Enabled := .F. 
       barcode.Button_8.Enabled := .T.   
       CodiGus08()
       RTFEAN08()
     ENDIF
   ENDIF
 
RETURN NIL

*------------------------------------------------------*
* FUNCTION _StrToEan8(tcString,.T.)       CODIGO EAN-8
*------------------------------------------------------*
* Convierte un string para ser impreso con
* fuente True Type "PF EAN P36"  "PF EAN P72"
* PARAMETROS:
*   tcString: Caracter de 7 dgitos (0..9)
*   tlCheckD: .T. Solo genera el dgito de control
*             .F. Genera dgito y caracteres a imprimir
* USO: _StrToEan8('1234567')
* RETORNA: Caracter
*------------------------------------------------------*
FUNCTION _StrToEan8(tcString,tlCheckD)

  aChecbo  := ( IIF(barcode.Check_1.Value,"True","False") )

   IF aChecbo = "True"
      MsgStop("Desmarque CheckBox para EAN-8","Desmarque CheckBox")
      RETURN
  ENDIF 
  
  PRIVATE lcLat, lcMed, lcRet, ; 
    lcIni, lcCod, lnI, ;
    lnCheckSum, lnAux       

  tcString := ALLTRIM( SUBSTR( barcode.Text_1X.value ,1,7))

  lcRet = ALLTRIM(tcString)
  IF LEN(lcRet) # 7        
      MsgBOX("La longitud de la cadena"+CHR(13)+;
             "debe ser 8 caracteres.","Error Cdigo EAN-8")
      RETURN ''
  ENDIF
   
   lnCheckSum = 0
   FOR lnI = 1 TO 7
     IF MOD(lnI,2) = 0
        lnCheckSum = lnCheckSum + VAL(SUBS(lcRet,lnI,1)) * 1
     ELSE
        lnCheckSum = lnCheckSum + VAL(SUBS(lcRet,lnI,1)) * 3
     ENDIF
   ENDFOR

   lnAux = MOD(lnCheckSum,10)
   lcRet = lcRet + ALLTRIM(STR(IIF(lnAux = 0, 0, 10-lnAux)))

    PasNew := SUBSTR( lcRet,1,8)              

   IF ALLTRIM(barcode.Text_1X.value) == PasNew         
       MsgInfo('Cdigo Verificado'+CRLF ;
             + ALLTRIM(PasNew) , 'Verificar Cdigo')  
             barcode.Text_1X.value := ALLTRIM(PasNew)   
             Play_BarEAN8()        
    ENDIF 

    IF ALLTRIM(barcode.Text_1X.value)  <> PasNew                      
       MsgInfo('Cdigo NO es Correcto'+CRLF ;
             + ALLTRIM(PasNew) ,'Verificar Cdigo')   
             barcode.Text_1X.value := ALLTRIM(PasNew)  
         
       RETURN NIL               
    ENDIF
 
  RETURN lcCod

*-------------------------------------*
* FUNCTION CheckDigitEan13(tcString)
*-------------------------------------*
* Agrega el Check Digit a un string para el cdigo de barra EAN-13
* "tcString" debe ser una cadena de caracteres de 12 dgitos [0..9]
* USO: CheckDigitEan13("123456789012")
* RETORNA: Caracter
*-------------------------------------*
  FUNCTION CheckDigitEan13(tcString)
*-------------------------------------*

   tcString :=   barcode.Text_1.value  

   lcRet = ALLTRIM(tcString)
   IF LEN(lcRet) # 13
      MsgBOX("La longitud de la cadena"+CHR(13)+;
             "debe ser 13 caracteres.","Error Cdigo EAN-13")
      RETURN 
   ENDIF

   lnCheckSum = 0
   FOR lnI = 1 TO 12
     IF MOD(lnI,2) = 0
        lnCheckSum = lnCheckSum + VAL(SUBS(lcRet,lnI,1)) * 3
     ELSE
        lnCheckSum = lnCheckSum + VAL(SUBS(lcRet,lnI,1)) * 1
     ENDIF
   ENDFOR

   lnAux = MOD(lnCheckSum,10)
   lcRet = lcRet + ALLTRIM(STR(IIF(lnAux = 0, 0, 10-lnAux)))

    New := ALLTRIM( SUBSTR( tcString ,1,12))

    PasNew := New + SUBSTR( lcRet,14,1)     

    IF tcString == PasNew
       MsgInfo('Cdigo Verificado'+CRLF ;
             + ALLTRIM(PasNew) , 'Verificar Cdigo')  
       barcode.Text_1.value := ALLTRIM(PasNew)   
       tcString :=  barcode.Text_1.value  
       Play_Barcode()       
    ENDIF

    IF tcString  <> PasNew
       MsgInfo('Cdigo NO es Correcto'+CRLF ;
             + ALLTRIM(PasNew) ,'Verificar Cdigo')   
       barcode.Text_1.value := ALLTRIM(PasNew)  
  
       RETURN NIL               
    ENDIF
 
 RETURN lcRet

*---------------------------------*
 FUNCTION EAN13_EAN8()
*---------------------------------*
   Local Mirax_13:= ALLTRIM(barcode.Text_1.value) 
   Local Mirax_08:= ALLTRIM(barcode.Text_1X.value) 

   aChecbo  := ( IIF(barcode.Check_1.Value,"True","False") )

   IF aChecbo = "True"
      barcode.Check_1.CAPTION:= "EAN-13 ?" 

     lcRet = Mirax_13    
    IF LEN(lcRet) # 13
       MsgStop('Cod:'+SPACE(1)+ALLTRIM(barcode.Text_1.value)+CRLF ; 
              +'Faltan n en el Cdigo','Error Cdigo EAN-13')   
              RETURN NIL 
     ELSE
       barcode.Button_4.Enabled := .T. 
       barcode.Button_8.Enabled := .F. 
       CodiGus13()
       Play_Barcode()  
    ENDIF
   ENDIF

   IF aChecbo = "False"
      barcode.Check_1.CAPTION := "EAN-8 ?" 
  
     lcRet = Mirax_08    
     IF LEN(lcRet) # 8
        MsgStop('Cod:'+SPACE(1)+ALLTRIM(barcode.Text_1X.value)+CRLF ; 
              +'Faltan n en el Cdigo','Error Cdigo EAN-08')   
       RETURN NIL 
     ELSE
       barcode.Button_4.Enabled := .F. 
       barcode.Button_8.Enabled := .T.  
       CodiGus08() 
       Play_BarEAN8()  
     ENDIF
   ENDIF
 
RETURN NIL

*--------------------------------------------------------*
 FUNCTION Play_Barcode()   //  Tipo EAN-13  (13 Dgitos)  
*--------------------------------------------------------*

   AddFont( "Letter\PF_I2OF5.TTF" )
  
  
*----------------Visor del Numero de Cdigo Barras-----------------*  

   cDescEfeito := barcode.Text_1.value  
   
   proA := ALLTRIM( SUBSTR( cDescEfeito,4,4))     

   artI := ALLTRIM( SUBSTR( cDescEfeito,8,5))            

*----------------------------------------------*

   CoPais := ALLTRIM( SUBSTR( cDescEfeito,1,3))    // <--------- Codigo Pais

*----------------------------------------------*
*---- Verificar si existe Cdigo del Pais -----*
*----------------------------------------------*

   SELECT 3
   USE COD_PAIS INDEX NUM_PAIS   //  ojo hay fallos ? .............
   CanTot := VAL(CoPais)                
   DbSeek(CanTot)
 
   IF .NOT. FOUND()
                     
        MsgInfo('Codigo Pais NO Existe','No Existe Codigo') 

        barcode.Text_1.value := " " 

      RETURN NIL
   ENDIF

*---------------------------------------------*

   SELECT 1 
   USE COD_PRO INDEX COD_PRO 

   Buscar := 400000 + VAL(proA)                 // <-------- Aadimos '400000' Para Crear n Proveedor	  

          COD_PRO->(DbSeek(Buscar))

           IF .NOT. FOUND()

                IF barcode.Tet_04.value <=SPACE(1)
                    MsgStop('Falta Nombre Proveedor !!!', 'Atencin Falta Proveedor')
                    RETURN NIL
                ENDIF

                IF MsgYesNo('Desea Crear Proveedor ? ','Crear Proveeedor' )
                           
                         SELECT 3
                         USE COD_PAIS INDEX NUM_PAIS   //  ojo hay fallos ? .............
                         CanTot := VAL(CoPais)                
                         DbSeek(CanTot)
 
                      IF .NOT. FOUND()                  // OJO-------------------------->   
                          MsgInfo('Codigo Pais NO Existe','No Existe Codigo') 
                          RETURN NIL
                      ELSE                                           
                         barcode.Tet_01.value   := COD_PAIS->COD_PAIS 
                         barcode.Tet_02.value   := COD_PAIS->PAIS     
                      ENDIF
                         SELECT 1 
                         APPEND BLANK 
                         REPLACE COD_PAIS WITH CanTot         
                         REPLACE PAIS WITH (barcode.Tet_02.value)     
                         REPLACE NUMER WITH Buscar
                         REPLACE R_SOCIAL WITH UPPER( barcode.Tet_04.value ) 

                         barcode.Brows_1.Value := recno()
                         barcode.Brows_1.Value := 1 
                         barcode.Brows_1.Refresh            
                         barcode.Brows_1.SetFocus   
    
                         dbGoTop()  
                             
                ELSE
                  MsgExclamation('No se Creo Proveedor')
                  RETURN
               ENDIF
          ENDIF

*---------------------------------------------*

   SELECT 2 
   USE COD_STO INDEX COD_STO 

   BuscarX :=  VAL(artI)
      
   COD_STO->(DbSeek(BuscarX))
             
   Canti   :=  CANTIDAD 
   ResPal  :=  VAL(ALLTRIM( barcode.Tet_06.value ))
   CanTot  :=  Canti +  Respal        
             
             IF .NOT. FOUND()

                IF barcode.Tet_05.value <=SPACE(1)
                    MsgStop('Falta Nombre Artculo !!!', 'Atencin Falta Artculo')
                    RETURN NIL
                ENDIF
                IF  VAL(ALLTRIM( barcode.Tet_06.value )) = 0
                    MsgStop('Falta Cantidad Artculos !!!', 'Atencin Falta Cantidad')
                    RETURN NIL
                ENDIF  

                IF MsgYesNo('Desea Crear Artculo ?','Crear Articulos' )
                         SELECT 2 
                         APPEND BLANK 
                         REPLACE C WITH .T. 
                         REPLACE COD_PAIS WITH VAL( CoPais) 
                         REPLACE NUMER WITH Buscar                      
                         REPLACE PAIS WITH (barcode.Tet_02.value)     
                         REPLACE NUMERO WITH Buscarx
                         REPLACE NOMBRE WITH UPPER( barcode.Tet_05.value ) 
                         REPLACE CANTIDAD WITH VAL(ALLTRIM( barcode.Tet_06.value ))
                         REPLACE FECHA_E WITH CTOD(barcode.Tet_07.value)  
                         REPLACE COD_EAN WITH VAL( ALLTRIM(barcode.Text_1.value)) 
                         dbGoTop()                        
                         barcode.Text_1.value := "0"        
                         barcode.Tet_04.value := " "
                         barcode.Tet_05.value := " "
                         barcode.Tet_06.value := "0"   
 
                         barcode.Brows_2.Value := recno() 
                         barcode.Brows_2.Value := 1 
                         barcode.Brows_2.Refresh            
                         barcode.Brows_2.SetFocus  
    
                         RETURN NIL 

                ELSE
                    MsgExclamation('No se Cre Artculo')                                                    
                         RETURN NIL 
                       
               ENDIF
            
           ENDIF       
          
           IF FOUND() 

                IF  VAL(ALLTRIM( barcode.Tet_06.value )) = 0
                    MsgStop('Falta Cantidad Artculos !!!', 'Atencin Falta Cantidad')
                    RETURN NIL
                ENDIF
      
                IF MsgYesNo('Desea Entrar Artculo ?','Entrada Articulos' )
                     
                         SELECT 2                  
                         REPLACE CANTIDAD WITH CanTot       
                         REPLACE FECHA_E WITH CTOD(barcode.Tet_07.value)    
                         dbGoTop()  
                         barcode.Text_1.value := "0"                                             
                         barcode.Tet_04.value := " "
                         barcode.Tet_05.value := " "
                         barcode.Tet_06.value := "0" 

                         barcode.Brows_1.Value := recno()
                         barcode.Brows_1.Value := 1 
                         barcode.Brows_1.Refresh            
                         barcode.Brows_1.SetFocus   

                         barcode.Brows_2.Value := recno() 
                         barcode.Brows_2.Value := 1 
                         barcode.Brows_2.Refresh            
                         barcode.Brows_2.SetFocus  
                         
                         RETURN NIL  
                      
                ELSE
                  MsgExclamation('No se Cre Artculo')                                
                         RETURN NIL
               ENDIF
            
           ENDIF 
      
  RETURN NIL
*---------------------------------*
 FUNCTION Play_BarEAN8()   //  Tipo EAN-8  ( 8 Dgitos)  
*---------------------------------*

   AddFont( "Letter\PF_I2OF5.TTF" )
   
*----------------Visor del Numero de Barras-----------------*   
    
   cDescEfeito := barcode.Text_1X.value  
    
   proA := ALLTRIM( SUBSTR( cDescEfeito,1,4))     

   artI := ALLTRIM( SUBSTR( cDescEfeito,5,4))            


*-----------------------------------------------------------*

   SELECT 1 
   USE COD_PRO INDEX COD_PRO 

   Buscar := 400000 + VAL(proA)                 // <-------- Aadimos '400000' Para Crear n Proveedor	  

          COD_PRO->(DbSeek(Buscar))

           IF .NOT. FOUND()

                IF barcode.Tet_04.value <=SPACE(1)
                    MsgStop('Falta Nombre Proveedor !!!', 'Atencin Falta Proveedor')
                    RETURN NIL
                ENDIF

                IF MsgYesNo('Desea Crear Proveedor ? ','Crear Proveeedor' )
                         SELECT 1 
                         APPEND BLANK 
                         REPLACE COD_PAIS WITH 840  
                         REPLACE NUMER WITH Buscar
                         REPLACE R_SOCIAL WITH UPPER( barcode.Tet_04.value )
                         REPLACE PAIS WITH "SPAIN" 
 
                         barcode.Brows_1.Value := recno() 
                         barcode.Brows_1.Value := 1 
                         barcode.Brows_1.Refresh            
                         barcode.Brows_1.SetFocus   
    
                         dbGoTop()  
                             
                ELSE
                  MsgExclamation('No se Creo Proveedor')
                  RETURN
               ENDIF
          ENDIF

*---------------------------------------------*

   SELECT 2 
   USE COD_STO INDEX COD_STO 

   BuscarX := 80000 + VAL(artI)
      
         COD_STO->(DbSeek(BuscarX))
             
   Canti   :=  CANTIDAD 
   ResPal  :=  VAL(ALLTRIM( barcode.Tet_06.value ))
   CanTot  :=  Canti +  Respal        
             
             IF .NOT. FOUND()

                IF barcode.Tet_05.value <=SPACE(1)
                    MsgStop('Falta Nombre Artculo !!!', 'Atencin Falta Artculo')
                    RETURN NIL
                ENDIF
                IF  VAL(ALLTRIM( barcode.Tet_06.value )) = 0
                    MsgStop('Falta Cantidad Artculos !!!', 'Atencin Falta Cantidad')
                    RETURN NIL
                ENDIF  

                IF MsgYesNo('Desea Crear Artculo ?','Crear Articulos' )
                         SELECT 2 
                         APPEND BLANK 
                         REPLACE C WITH .F. 
                         REPLACE NUMERO WITH Buscarx
                         REPLACE NUMER WITH Buscar
                         REPLACE COD_PAIS WITH 840   
                         REPLACE PAIS WITH "SPAIN"  
                         REPLACE NOMBRE WITH UPPER( barcode.Tet_05.value ) 
                         REPLACE CANTIDAD WITH VAL(ALLTRIM( barcode.Tet_06.value ))
                         REPLACE FECHA_E WITH CTOD(barcode.Tet_07.value)  
                         REPLACE COD_EAN WITH VAL( ALLTRIM(barcode.Text_1X.value))  
                         dbGoTop()                              
                         barcode.Text_1X.value := "0"       
                         barcode.Tet_04.value  := " "
                         barcode.Tet_05.value  := " "
                         barcode.Tet_06.value  := "0" 
                   
                         barcode.Brows_2.Value := recno()
                         barcode.Brows_2.Value := 1 
                         barcode.Brows_2.Refresh            
                         barcode.Brows_2.SetFocus   
                      
                         RETURN NIL 
                ELSE
                  MsgExclamation('No se Cre Artculo') 
                                                    
                         RETURN NIL 
                       
               ENDIF
            
           ENDIF       
          
           IF FOUND() 

                IF  VAL(ALLTRIM( barcode.Tet_06.value )) = 0
                    MsgStop('Falta Cantidad Artculos !!!', 'Atencin Falta Cantidad')
                    RETURN NIL
                ENDIF
      
                IF MsgYesNo('Desea Entrar Artculo ?','Entrada Articulos' )
                     
                         SELECT 2                  
                         REPLACE CANTIDAD WITH CanTot       
                         REPLACE FECHA_E WITH CTOD(barcode.Tet_07.value)    
                         dbGoTop()   
                         barcode.Text_1X.value := "0"                                                                  
                         barcode.Tet_04.value  := " "
                         barcode.Tet_05.value  := " "
                         barcode.Tet_06.value  := "0" 

                         barcode.Brows_2.Value := recno()
                         barcode.Brows_2.Value := 1 
                         barcode.Brows_2.Refresh            
                         barcode.Brows_2.SetFocus   
    
                         RETURN NIL  
                      
                ELSE
                  MsgExclamation('No se Cre Artculo')                                
                         RETURN NIL
               ENDIF
            
           ENDIF 
      
  RETURN NIL

*----------------------------------*
 FUNCTION EraserEAN13EAN8()
*----------------------------------*

  aChecbo  := ( IIF(barcode.Check_1.Value,"True","False") )

  IF aChecbo = "True"
     barcode.Text_1.Visible   := .T.
     barcode.Text_1X.visible  := .F.
     barcode.Button_4.Enabled := .T. 
     barcode.Button_8.Enabled := .F.   
     EraSer13()
  ENDIF

  IF aChecbo = "False"
     barcode.Text_1.Visible   := .F.
     barcode.Text_1X.visible  := .T.
     barcode.Button_4.Enabled := .F.  
     barcode.Button_8.Enabled := .T. 
     EraSer08()
  ENDIF

 RETURN NIL
*---------------------------------*  
 FUNCTION EraSer13()
*---------------------------------*  

   cDescEfeito := barcode.Text_1.value  

   artI := ALLTRIM( SUBSTR( cDescEfeito,8,5))            

   SELECT 2 
   USE COD_STO INDEX COD_STO 

   BuscarX := VAL(artI)
  
   COD_STO->(DbSeek(BuscarX))
             
   Nomix   :=  NOMBRE 
   Canti   :=  CANTIDAD 
   ResPal  :=  VAL(ALLTRIM( barcode.Tet_06.value ))
   CanTot  :=  Canti -  Respal       
             
             IF .NOT. FOUND()

                IF barcode.Tet_05.value <=SPACE(1)
                    MsgStop('Falta Nombre Artculo !!!', 'Atencin Falta Artculo')
                    RETURN NIL
                ENDIF
                IF  VAL(ALLTRIM( barcode.Tet_06.value )) = 0
                    MsgStop('Falta Cantidad Artculos !!!', 'Atencin Falta Cantidad')
                    RETURN NIL
                ENDIF  
                            
           ENDIF       
          
           IF FOUND()
               
               IF VAL(ALLTRIM( barcode.Tet_06.value )) > 0   
                       
                      IF MsgYesNo('Desea Modificar Artculo ?','Modificar Artculo !!!')           

                         MsgInfo('Cod:'+SPACE(1)+STR(BuscarX)+CRLF ; 
                                + ALLTRIM(Nomix)+CRLF;  
                                +'Articulo:'+SPACE(1)+ STR(ResPal)+SPACE(1)+'Modificado','Modificacin')   
                         SELECT 2 
                         REPLACE CANTIDAD WITH CanTot        
                         REPLACE FECHA_E WITH CTOD(barcode.Tet_07.value)  
                         dbGoTop()                                                           
                         barcode.Text_1.value := "0"         
                         barcode.Tet_04.value := " "
                         barcode.Tet_05.value := " "
                         barcode.Tet_06.value := "0" 

                         barcode.Brows_2.Value := recno()
                         barcode.Brows_2.Value := 1 
                         barcode.Brows_2.Refresh            
                         barcode.Brows_2.SetFocus   
    
                         RETURN NIL  
                       ELSE  

                         MsgExclamation('No se Modific Artculo')
                      
                         RETURN NIL
                      ENDIF  

               ENDIF

              IF VAL(ALLTRIM( barcode.Tet_06.value )) <= 0
                     
                    IF MsgYesNo('Desea Borrar Artculo ?','Borrar Articulos!!!')
                          SELECT 2 
                          REPLACE CANTIDAD WITH 0  
                          DELETE FOR CANTIDAD = 0
                          PACK
                          dbGoTop() 
                          barcode.Text_1.value := "0"          
                          barcode.Tet_04.value := " "
                          barcode.Tet_05.value := " "
                          barcode.Tet_06.value := "0" 

                          barcode.Brows_2.Value := recno()
                          barcode.Brows_2.Value := 1 
                          barcode.Brows_2.Refresh            
                          barcode.Brows_2.SetFocus   
    
                          RETURN NIL
                   ELSE  
                      MsgExclamation('No se Borr Artculo') 

                         RETURN NIL
                   ENDIF  
              ENDIF
            
           ENDIF 
   
 RETURN NIL 

*---------------------------------*  
 FUNCTION EraSer08()
*---------------------------------*  

   cDescEfeito := barcode.Text_1X.value  

   artI := ALLTRIM( SUBSTR( cDescEfeito,5,4))    

   SELECT 2 
   USE COD_STO INDEX COD_STO 

   BuscarX := 80000 + VAL(artI)
  
   COD_STO->(DbSeek(BuscarX))
             
   Nomix   :=  NOMBRE 
   Canti   :=  CANTIDAD 
   ResPal  :=  VAL(ALLTRIM( barcode.Tet_06.value ))
   CanTot  :=  Canti -  Respal       
             
             IF .NOT. FOUND()

                IF barcode.Tet_05.value <=SPACE(1)
                    MsgStop('Falta Nombre Artculo !!!', 'Atencin Falta Artculo')
                    RETURN NIL
                ENDIF
                IF  VAL(ALLTRIM( barcode.Tet_06.value )) = 0
                    MsgStop('Falta Cantidad Artculos !!!', 'Atencin Falta Cantidad')
                    RETURN NIL
                ENDIF  
                            
           ENDIF       
          
           IF FOUND()
               
               IF VAL(ALLTRIM( barcode.Tet_06.value )) > 0   
                       
                      IF MsgYesNo('Desea Modificar Artculo ?','Modificar Artculo !!!')           

                         MsgInfo('Cod:'+SPACE(1)+STR(BuscarX)+CRLF ; 
                                + ALLTRIM(Nomix)+CRLF;  
                                +'Articulo:'+SPACE(1)+ STR(ResPal)+SPACE(1)+'Modificado','Modificacin')   
                         SELECT 2 
                         REPLACE CANTIDAD WITH CanTot        
                         REPLACE FECHA_E WITH CTOD(barcode.Tet_07.value)  
                         dbGoTop() 
                         barcode.Text_1X.value := "0"                                             
                         barcode.Tet_04.value  := " "
                         barcode.Tet_05.value  := " "
                         barcode.Tet_06.value  := "0" 
                        
                         barcode.Brows_2.Value := recno() 
                         barcode.Brows_2.Value := 1 
                         barcode.Brows_2.Refresh            
                         barcode.Brows_2.SetFocus   
    
                         RETURN NIL  
                       ELSE  

                         MsgExclamation('No se Modific Artculo')
                      
                         RETURN NIL
                      ENDIF  

               ENDIF

              IF VAL(ALLTRIM( barcode.Tet_06.value )) <= 0
                     
                    IF MsgYesNo('Desea Borrar Artculo ?','Borrar Articulos!!!')
                          SELECT 2 
                          REPLACE CANTIDAD WITH 0  
                          DELETE FOR CANTIDAD = 0
                          PACK
                          dbGoTop()  
                          barcode.Text_1X.value := "0"         
                          barcode.Tet_04.value  := " "
                          barcode.Tet_05.value  := " "
                          barcode.Tet_06.value  := "0" 

                          barcode.Brows_2.Value := recno()
                          barcode.Brows_2.Value := 1 
                          barcode.Brows_2.Refresh            
                          barcode.Brows_2.SetFocus   
                       
                          RETURN NIL
                   ELSE  
                      MsgExclamation('No se Borr Artculo') 

                         RETURN NIL
                   ENDIF  
              ENDIF
            
           ENDIF 
   
 RETURN NIL 

*---------------------------------*
 FUNCTION ImpBarras()
*---------------------------------*

 Local  lSuccess, nCant, DibBarras   

 aChecbo  := ( IIF(barcode.Check_1.Value,"True","False") )

    IF aChecbo = "True"

 If Empty (BarCode.Text_1.value)
    Msginfo("Ingrese los datos...")
    return
 endif

 SELECT PRINTER DIALOG TO lSuccess

 AddFont( "Letter\PF_I2OF5.TTF" )

 START PRINTDOC

   START PRINTPAGE
 
         DibBarras   :=  _StrToI2of5( barCode.Text_1.value )
       
         cDescEfeito := ALLTRIM(barcode.Text_1.value)    
 
         @ 20,40 PRINT DibBarras Font "PF Interleaved 2 of 5" Size 45

         @ 40,40 PRINT cDescEfeito  Font "Arial" Size 13

   END PRINTPAGE

 END PRINTDOC

    ELSE

   
 If Empty (BarCode.Text_1x.value)
   Msginfo("Ingrese los datos...")
   return
 endif

 SELECT PRINTER DIALOG TO lSuccess

 AddFont( "Letter\PF_I2OF5.TTF" )

 START PRINTDOC

   START PRINTPAGE


      DibBarras   :=  _StrToI2of5( barCode.Text_1X.value )
       
         cDescEfeito := ALLTRIM(barcode.Text_1X.value)    
 
         @ 20,40 PRINT DibBarras Font "PF Interleaved 2 of 5" Size 45

         @ 40,40 PRINT cDescEfeito  Font "Arial" Size 13


   END PRINTPAGE

 END PRINTDOC

      ENDIF

 RemoveFont("Letter\PF_I2OF5.TTF")

RETURN 

*---------------------------------* 
 FUNCTION AddFont(font)
*---------------------------------* 

   #define FR_PRIVATE  0x10
   #define FR_NOT_ENUM 0x20
   local nRet := AddFontResourceEx( font,FR_PRIVATE+ FR_NOT_ENUM, 0)

   RETURN Nil
*---------------------------------*   
 FUNCTION RemoveFont(font)
*---------------------------------*

   #define FR_PRIVATE 0x10
   #define FR_NOT_ENUM 0x20
   local nRet := RemoveFontResourceEx( font,FR_PRIVATE+ FR_NOT_ENUM, 0)

   RETURN Nil
*---------------------------------*   
 FUNCTION _StrToI2of5(cString)
*---------------------------------*

   local cStart, cStop, cRet, cCheck, cCar, nLong, nI, nSum, nAux

   cStart := chr(40)
   cStop  := chr(41)
   cRet   := alltrim(cString)

   *--- Genero dgito de control
   nLong  := len(cRet)
   nSum   := 0
   nCount := 1
   for nI := nLong to 1 step -1
      nSum   := nSum + val(substr(cRet,nI,1)) * iif(mod(nCount,2) = 0,1,3)
      nCount := nCount + 1
   next
   nAux  := mod(nSum,10)
   cRet  := cRet + alltrim(str(iif(nAux = 0,0,10 - nAux)))
   nLong := len(cRet)

   *--- La longitud debe ser par
   if mod(nLong,2) # 0
      cRet  := '0' + cRet
      nLong := len(cRet)
   endif

   *--- Convierto los pares a caracteres
   cCar = ''
   for nI := 1 to nLong step 2
      if val(subs(cRet,nI,2)) < 50
         cCar := cCar + chr(val(subs(cRet,nI,2)) + 48)
      else
         cCar := cCar + chr(val(subs(cRet,nI,2)) + 142)
      endif
   next

  *--- Armo cdigo
  cRet := cStart + cCar + cStop

   RETURN( cRet )
*---------------------------------*

   DECLARE DLL_TYPE_INT   AddFontResourceEx    ( DLL_TYPE_LPCTSTR lpszFilename, DLL_TYPE_DWORD fl, DLL_TYPE_LPVOID pdv ) IN GDI32.DLL
   DECLARE DLL_TYPE_BOOL  RemoveFontResourceEx ( DLL_TYPE_LPCTSTR lpFileName  , DLL_TYPE_DWORD fl, DLL_TYPE_LPVOID pdv ) IN GDI32.DLL

