* Function Original de brunellopulix (brunellopulix@yahoo.it)

# include "hbclass.ch"
# include 'common.ch'
# define CRLF  chr(13)+chr(10)
#translate NTRIM( <v1> ) => ( Ltrim(str(<v1>)) )
*
FUNCTION BinToBar(cBar)
   LOCAL n
   LOCAL Stringa
   LOCAL x
   *
   Stringa      := ""
   x            := 0
   FOR n := 1 TO Len(cBar)
      IF SubStr(cBar, n, 1) = "1"
         Stringa += CHR(255) + CHR(255)
      ELSE
         Stringa += CHR(0) + CHR(0)
      ENDIF
      x++
   NEXT
RETURN CHR(27)+CHR(76)+CHR(x*2)+CHR(0)+stringa
*
FUNCTION CodToStr(cStringBar)
   LOCAL Strlen
   LOCAL cBar
   LOCAL ean8
   LOCAL ean13
   LOCAL nPos
   LOCAL jPos
   LOCAL yPos
   LOCAL i
   LOCAL nflag
   *
   Strlen := Len(AllTrim(cStringBar))
   cBar   := ""
   ean8   := {"_A", "_A", "_A", "_A", "_C", "_C", "_C", "_C"}
   ean13  := {;
   {"_A","_A","_A","_A","_A","_A","_C","_C","_C","_C","_C","_C","_C"},;
   {"_A","_A","_B","_A","_B","_B","_C","_C","_C","_C","_C","_C","_C"},;
   {"_A","_A","_B","_B","_A","_B","_C","_C","_C","_C","_C","_C","_C"},;
   {"_A","_A","_B","_B","_B","_A","_C","_C","_C","_C","_C","_C","_C"},;
   {"_A","_B","_A","_A","_B","_B","_C","_C","_C","_C","_C","_C","_C"},;
   {"_A","_B","_B","_A","_A","_B","_C","_C","_C","_C","_C","_C","_C"},;
   {"_A","_B","_B","_B","_A","_A","_C","_C","_C","_C","_C","_C","_C"},;
   {"_A","_B","_A","_B","_A","_B","_C","_C","_C","_C","_C","_C","_C"},;
   {"_A","_B","_A","_B","_B","_A","_C","_C","_C","_C","_C","_C","_C"},;
   {"_A","_B","_B","_A","_B","_A","_C","_C","_C","_C","_C","_C","_C"}}
   *
   nflag:= Val(Left(cStringBar, 1))+1
   *
   IF Strlen   == 8
      jPos     := 0
      yPos     := 5
   ELSE
      jPos     := 1
      yPos     := 7
   ENDIF
   * inizio stringa
   *   cBar    := DaiCode(1,"_D")
   cBar    := "A"
   FOR i := 1 TO StrLen
      *
      nPos := Val(SubStr(cStringBar,i+jPos,1))+1
      IF i == yPos
         *cBar    += DaiCode(1,"_E")
         cBar    += "B"
      ENDIF
      IF Strlen == 8
         cBar += DaiCode(nPos,ean8[i])
      ELSE
         cBar += DaiCode(nPos,EAN13[nflag,i])
      ENDIF
   NEXT
   * chiusura stringa
   *   cBar    += DaiCode(1,"_D")
   cBar    += "A"
   *
RETURN cBar
*
STATIC FUNCTION DaiCode(nRow,cCol)
STATIC aCode  := {}
STATIC aIndex := {}
LOCAL nCol
*
IF Empty(aIndex)
   aIndex := {"_A","_B","_C","_D","_E","_F"}
ENDIF
IF Empty(aCode)
   aCode := {;
   {"0001101","0100111","1110010","101","01010","010101"},;
   {"0011001","0110011","1100110","101","01010","010101"},;
   {"0010011","0011011","1101100","101","01010","010101"},;
   {"0111101","0100001","1000010","101","01010","010101"},;
   {"0100011","0011101","1011100","101","01010","010101"},;
   {"0110001","0111001","1001110","101","01010","010101"},;
   {"0101111","0000101","1010000","101","01010","010101"},;
   {"0111011","0010001","1000100","101","01010","010101"},;
   {"0110111","0001001","1001000","101","01010","010101"},;
   {"0001011","0010111","1110100","101","01010","010101"}}
ENDIF
*
nCol := AScan(aIndex, cCol)
*
RETURN aCode[nRow,nCol]
*
FUNCTION DecHex(nNumber)
   LOCAL cNewString := ''
   LOCAL nTemp := 0
   *
   DO WHILE (nNumber > 0)
      nTemp := (nNumber%16)
      cNewString := SubStr('0123456789ABCDEF',(nTemp+1),1)+cNewString
      nNumber := Int((nNumber-nTemp)/16)
   ENDDO
RETURN Right('00'+cNewString,2)
*
Procedure HeaderBmp(nHandle,nWidth,nHeight)
   *
   FWrite(nHandle,CHR(66)+CHR(77)+CHR(62)+CHR(2)+;
   CHR(0)+CHR(0)+CHR(0)+CHR(0)+CHR(0)+CHR(0)+CHR(62)+;
   CHR(0)+CHR(0)+CHR(0)+CHR(40)+CHR(0)+CHR(0)+CHR(0)+;
   CHR(nWidth)+CHR(0)+CHR(0)+CHR(0)+CHR(nHeight)+CHR(0)+CHR(0)+;
   CHR(0)+CHR(1)+CHR(0)+CHR(1)+CHR(0)+CHR(0)+CHR(0)+CHR(0)+;
   CHR(0)+CHR(0)+CHR(2)+CHR(0)+CHR(0)+CHR(0)+CHR(0)+CHR(0)+;
   CHR(0)+CHR(0)+CHR(0)+CHR(0)+CHR(0)+CHR(0)+CHR(0)+CHR(0)+;
   CHR(0)+CHR(0)+CHR(0)+CHR(0)+CHR(0)+CHR(0)+CHR(0)+CHR(0)+;
   CHR(0)+CHR(255)+CHR(255)+CHR(255)+CHR(0))
   *
RETURN
*
STATIC Procedure Scrivi(aCode,aR,x,cType)
LOCAL n,i
LOCAL Stringa1,Stringa2
*
FOR n := 1 TO x
   Stringa1 := ""
   Stringa2 := ""
   FOR i := 1 TO Len(aR)
      stringa1 += CHR(aR[i])
      stringa2 += DecHex(aR[i])
   NEXT
   IF cType == "BMP"
      AAdd(aCode,Stringa1)
   ELSE
      AAdd(aCode,Stringa2)
   ENDIF
NEXT
RETURN
*
STATIC FUNCTION xNumero(cNum)
LOCAL _i
LOCAL y
LOCAL aNum := Array(7)
*
AFill(aNum,"")
*
FOR _i := 1 TO Len(cNum)
   y := SubStr(cNum,_i,1)
   DO CASE
      CASE y == "1"
         aNum[1] += "0011000"
         aNum[2] += "0111000"
         aNum[3] += "1111000"
         aNum[4] += "0011000"
         aNum[5] += "0011000"
         aNum[6] += "0011000"
         aNum[7] += "1111100"
      CASE y == "2"
         aNum[1] += "0111000"
         aNum[2] += "1101100"
         aNum[3] += "0001100"
         aNum[4] += "0011000"
         aNum[5] += "0110000"
         aNum[6] += "1100000"
         aNum[7] += "1111100"
      CASE y == "3"
         aNum[1] += "0111000"
         aNum[2] += "1001100"
         aNum[3] += "0001100"
         aNum[4] += "0111000"
         aNum[5] += "0001100"
         aNum[6] += "1001100"
         aNum[7] += "0111000"
      CASE y == "4"
         aNum[1] += "0001100"
         aNum[2] += "0011100"
         aNum[3] += "0101100"
         aNum[4] += "1001100"
         aNum[5] += "1111110"
         aNum[6] += "0001100"
         aNum[7] += "0111110"
      CASE y == "5"
         aNum[1] += "1111100"
         aNum[2] += "1100000"
         aNum[3] += "1110000"
         aNum[4] += "1001100"
         aNum[5] += "0001100"
         aNum[6] += "1001100"
         aNum[7] += "0111000"
      CASE y == "6"
         aNum[1] += "0011100"
         aNum[2] += "0110000"
         aNum[3] += "1100000"
         aNum[4] += "1111000"
         aNum[5] += "1101100"
         aNum[6] += "1101100"
         aNum[7] += "0111000"
      CASE y == "7"
         aNum[1] += "1111110"
         aNum[2] += "1000110"
         aNum[3] += "0000110"
         aNum[4] += "0000110"
         aNum[5] += "0001100"
         aNum[6] += "0001100"
         aNum[7] += "0001100"
      CASE y == "8"
         aNum[1] += "0111000"
         aNum[2] += "1101100"
         aNum[3] += "1101100"
         aNum[4] += "0111000"
         aNum[5] += "1101100"
         aNum[6] += "1101100"
         aNum[7] += "0111000"
      CASE y == "9"
         aNum[1] += "0111100"
         aNum[2] += "1100110"
         aNum[3] += "1100110"
         aNum[4] += "0111110"
         aNum[5] += "0000110"
         aNum[6] += "0001100"
         aNum[7] += "1111000"
      CASE y == "0"
         aNum[1] += "0111000"
         aNum[2] += "1101100"
         aNum[3] += "1101100"
         aNum[4] += "1101100"
         aNum[5] += "1101100"
         aNum[6] += "1101100"
         aNum[7] += "0111000"
      CASE y == "."
         aNum[1] += "00"
         aNum[2] += "00"
         aNum[3] += "00"
         aNum[4] += "00"
         aNum[5] += "00"
         aNum[6] += "00"
         aNum[7] += "11"
      CASE y == ","
         aNum[1] += "00000"
         aNum[2] += "00000"
         aNum[3] += "00000"
         aNum[4] += "00000"
         aNum[5] += "00000"
         aNum[6] += "00000"
         aNum[7] += "00000"
      CASE y == ";"
         aNum[1] += "0000000"
         aNum[2] += "0000000"
         aNum[3] += "0000000"
         aNum[4] += "0000000"
         aNum[5] += "0000000"
         aNum[6] += "0000000"
         aNum[7] += "0000000"
      CASE y == ":"
         aNum[1] += "000"
         aNum[2] += "000"
         aNum[3] += "000"
         aNum[4] += "000"
         aNum[5] += "000"
         aNum[6] += "000"
         aNum[7] += "000"
         
   ENDCASE
NEXT
*
RETURN aNum
*
STATIC FUNCTION XXX(xString)
LOCAL j     := 1
LOCAL aTemp := {}
LOCAL n
*
FOR n := 1 TO 16
   AAdd(aTemp,YYY(SubStr(xString,j,8)))
   j += 8
NEXT
RETURN aTemp
*
STATIC FUNCTION YYY(s)
LOCAL n
LOCAL xVal
LOCAL b := {128,64,32,16,8,4,2,1}
*
xVal := 256
FOR n := 1 TO Len(s)
   IF Val(SubStr(s,n,1)) > 0
      xVal -= b[n]
   ENDIF
NEXT
RETURN xVal-1
*
FUNCTION BarToBmp(xCode,xFileBmp,scalex,scaley)
   LOCAL a0,a1,a2,a3,a4,a5
   LOCAL i,j
   LOCAL cSep0,cSep00,cSep000
   LOCAL cBar,cSep2,cSep3
   LOCAL nhandle
   LOCAL xCode2
   LOCAL nWidth
   LOCAL aCode
   LOCAL cType
   LOCAL aRay
   LOCAL nHeight
   *
   Default  scalex to 100
   Default  scaley to 100
   *
   aCode := {}
   IF Empty(xFileBmp)
      cType := "RTF"
   ELSE
      cType := "BMP"
   ENDIF
   *
   nWidth := 128
   *IF IsNil(nHeight)
   nHeight := 32
   *ENDIF
   *
   cSep0   := Replicate('0',16)
   IF Val(xCode) > 99999999
      xCode  := StrZero(Val(xCode),13)
      xCode2 := Left(xCode,1)+','+SubStr(xCode,2,6)+';'+SubStr(xCode,8,6)
      cSep00 := '00000000'
   ELSE
      xCode  := StrZero(Val(xCode),8)
      xCode2 := Left(xCode,4)+':'+Right(xCode,4)
      cSep00 := '00000000000000000000'
   ENDIF
   cSep000 := Replicate('0',nWidth)
   *
   a4    := xNumero(xCode2)
   *
   cBar  := CodToStr(xCode)              && barcode         |||||||||||||||
   cSep2 := StrTran(cBar,'1','0')        && separatori (3)  |      |      |
   cSep3 := StrTran(cBar,'1','0')        && separatori (2)  |             |
   *
   cBar  := StrTran(cBar,'A','101')
   cBar  := StrTran(cBar,'B','01010')
   cBar  := Left(cSep0+cBar+cSep000,nWidth)
   a1    := XXX(cBar)
   *
   cSep2 := StrTran(cSep2,'A','101')
   cSep2 := StrTran(cSep2,'B','01010')
   cSep2 := Left(cSep0+cSep2+cSep000,nWidth)
   a2    := XXX(cSep2)
   *
   cSep3 := StrTran(cSep3,'A','101')
   cSep3 := StrTran(cSep3,'B','00000')
   cSep3 := Left(cSep0+cSep3+cSep000,nWidth)
   a3    := XXX(cSep3)
   *
   a0 := Array(Len(a1))
   AFill(a0,255)
   ****************************************************************************
   Scrivi(aCode,a0,2,cType)                        && 2 righe vuote
   j := Len(a4)                                    &&
   FOR i := 1 TO Len(a4)                           &&
      a5 := XXX(Left(cSep00+a4[j--],nWidth))       && scrive codice in lettere
      Scrivi(aCode,a5,1,cType)                     && su 7 righe
   NEXT
   Scrivi(aCode,a3,1,cType)                        && 1 riga separatore 2
   Scrivi(aCode,a2,2,cType)                        && 2 righe separatore 3
   Scrivi(aCode,a1,nHeight-16,cType)               && codice a barre
   Scrivi(aCode,a0,4,cType)                        && 4 righe vuote
   ****************************************************************************
   *
   aRay := {}
   IF cType == "BMP"
      nhandle := FCreate(xFileBmp,0)               && Crea il file
      HeaderBmp(nHandle,nWidth,nHeight)            && Scrive header
      FOR i := 1 TO Len(aCode)
         FWrite(nhandle,aCode[i])
      NEXT
      FClose(nHandle)                              && Chiude file
   ELSE
      AAdd(aRay,"{\pict\wbitmap0\wbmbitspixel1\wbmplanes1\wbmwidthbytes16\picw128\pich32\picscalex"+NTrim(scalex)+"\picscaley"+NTrim(scaley)+"\picwgoal1920\pichgoal480")
      FOR i := Len(aCode) TO 1 STEP -1
         AAdd(aRay,aCode[i])
      NEXT
      AAdd(aRay,"}")
      AAdd(aRay,"\par")
   ENDIF
   *   Avviso(NTrim(Len(aRay)))
   
   *
RETURN aRay
*
FUNCTION MkCodeBar(xCode,scalex,scaley)
   LOCAL xBar := ""
   LOCAL aBar := {}
   *
   Default scalex to 100
   Default scaley to 100
   *
   aBar  := BarToBmp(xCode,"",scalex,scaley)
   ASize(aBar,Len(aBar)-1)
   xBar := ArToSt(aBar,CRLF)
   *
RETURN xBar
*
