
*------------------------------------ BoxLetterShoW --------------------------*
*------- Idea Orginal Cedida        : Lucho Miranda   ElSalnes@telefonica.net * 
*------- Routine donated by         : Lucho Miranda   ElSalnes@telefonica.net *
*------- Funciones y Areglos        : Mustafa Lpez   mustalopez@gmail.com    * 
*------- Functions and Arrangements : Mustafa Lpez   mustalopez@gmail.com    *
*-----------------------------------------------------------------------------*

*  Color de Fondo de Window ------->  color crema  {239,235,222}   ( Obcional )  

*---------------------------------------------------------------------------------------------------*
Func Box(CurSRow, CurSCol, LastSWidth, LastSHeight , NOSm , SColor01 , SColor02, SColor03 )
*---------------------------------------------------------------------------------------------------*
 ***                       Normal Sintax

 ***   @ 110,120 LABEL Label_01  WIDTH 200 HEIGHT 058 ;
 ***             FONT "Ms Sans Serif" SIZE 0011 BORDER CLIENTEDGE BACKCOLOR {128,126,255} <----------- Box

 ***   @ 275,320 LABEL Label_14  WIDTH 250 HEIGHT 003 ;
 ***             FONT "Ms Sans Serif" SIZE 0011 BORDER CLIENTEDGE BACKCOLOR {255,255,255} <----------- Line   

*------------------------- New Sintax ---------------------------------------------------------*

 ***           Sample Parameters Box ------>  ( Caja sin Fondo y Hacer Lineas) (Bottomless Box and Make Lines)

 ***  Row -------->  CurSRow     = 110 
 ***  Col -------->  CurSCol     = 120
 ***  WIDTH ------>  LasSWidth   = 200
 ***  HEIGHT ----->  LastSHeight = 058
 ***  Label name ->  Sclavel01  := ALLTRIM("Label_") + ALLTRIM(NoSm)= Label_01
 ***  SizSeL ----->  SizSex     :=  SizSeL  ------------> FONTSIZE 11
 ***  SColorx := { SColor01 , SColor02 , SColor03 } ----> BACKCOLOR {128,126,255} 
 
 ***             Language Syntax Sample   

 ***  Box(110, 120, 200, 058 ,"01", 11, 128,126,255 ) <----------- Box
 ***  Box(275, 320, 250, 003 ,"14", 11, 255,255,255 ) <----------- Line   

*---------------------------------------------------------------------------------------------*

 Local Sclavel01 :=   ALLTRIM("Label_") + ALLTRIM(NoSm) 
 Local SColorx   := { SColor01 , SColor02 , SColor03 }  

    DEFINE label &Sclavel01        
         ROW   CurSRow
         COL   CurSCol  
         WIDTH  LastSWidth 
         HEIGHT LastSHeight 
         BACKCOLOR SColorx              
         BORDER .T.
         CLIENTEDGE .T.
    END LABEL
 
Return

*---------------------------------------------------------------------------------------------*
Func   BOXBOX( CurSRowx, CurSColx, LastSWidthx, LastSHeightx , Lab ,  Entexe )
*---------------------------------------------------------------------------------------------*

 ***                       Normal Sintax 
*-----------------------------  Box Raya ---------------------------------*
 ***  @ 016,015 LABEL Label_BOX_IN00 WIDTH 545 HEIGHT 355 ;
 ***           FONT "Ms Sans Serif" SIZE 0011 BOLD ITALIC BORDER  

 ***              Form_1.Label_BOX_IN00.Enabled := .F.
*-------------------------------------------------------------------------*
*------------------------------ Box Undido--------------------------------*
  
***  @ 074,033 LABEL Label_BOX_IN01 WIDTH 175 HEIGHT 255 ;
***            FONT "Ms Sans Serif" SIZE 0011 BORDER CLIENTEDGE         
              
***               Form_1.Label_BOX_IN01.Enabled := .F.
*-------------------------------------------------------------------------*

*------------------------- New Sintax ---------------------------------------------------------*

 ***           Sample Syntax Parameters BoxBox  -----> ( Cuadro Normal y Hundido ) ( Box Normal and Sunk)  

 ***  Row -------->  CurZRowx         = 016
 ***  Col -------->  CurZColx         = 015
 ***  WIDTH ------>  LasZWidthx       = 545
 ***  HEIGHT ----->  LasZHeightx      = 355
 ***  Label name ->  LclaveZ02        := ALLTRIM("Label_") + ALLTRIM(Lab) = Label_BOX_IN00
 ***  Entexe  ---->  .F. OR .T.     


 
 ***              Language Sample  

 ***      BOXBOX( 016 , 015 , 545 , 355 , "BOX_IN00",.F. )    <------  Box Raya  -----> BOLD ITALIC BORDER    

 ***                     Form_1.Label_BOX_IN00.Enabled := .F.
*------------------------------------------------------------------------------------------------*

 ***      BOXBOX( 074 , 033 , 175 , 255 , "BOX_IN01",.T. )    <-----   Box Undido ----> BORDER CLIENTEDGE     


 ***                     Form_1.Label_BOX_IN01.Enabled := .F.

*------------------------------------------------------------------------------------------------*

 Local Sclavel02 :=   ALLTRIM("Label_") + ALLTRIM(Lab) 
 Local ENTEDGE   :=   Entexe  


    DEFINE label &Sclavel02       
         ROW   CurSRowx
         COL   CurSColx  
         WIDTH  LastSWidthx 
         HEIGHT LastSHeightx 
         FONTNAME "Ms Sans Serif"
         FONTSIZE 11
         FONTBOLD .T.
         FONTITALIC .T.          
         BORDER .T.
         CLIENTEDGE ENTEDGE       //  <---------  .F. OR .T.   
    END LABEL
 
Return

*--------------------------------------------------------------------------------------------*
Func BoxShadow(CurRow, CurCol, LastWidth, LastHeight, Nom, Num , Color01 , Color02, Color03 )
*--------------------------------------------------------------------------------------------*
 ***                       Normal Sintax
  
 ***          @ 110,120 LABEL Label_01 WIDTH 200 HEIGHT 058 ;
 ***                    FONT "Ms Sans Serif" SIZE 011 BACKCOLOR  {000,000,000}  

 ***          @ 105,115 LABEL Label_02  WIDTH 200 HEIGHT 058 ;
 ***                    FONT "Ms Sans Serif" SIZE 011 BORDER CLIENTEDGE BACKCOLOR  {128,126,255}  

*------------------------- New Sintax ---------------------------------------------------------*

 ***  Sample Syntax Parameters BoxShadow  ---->    (Caja con Fondo y Sombra) (Fund and Shadow Box) 

 ***  Row -------->  CurRow  = 110 
 ***  Col -------->  CurCol  = 120
 ***  WIDTH ------>  LastWidth  = 200
 ***  HEIGHT ----->  LastHeight = 058
 ***  Label name ->  clavel01 := ALLTRIM("Label_") + ALLTRIM(Nom) = Label_01
 ***  Label name ->  clavel02 := ALLTRIM("Label_") + ALLTRIM(Num) = Label_02
 ***  Colorx := { Color01 , Color02 , Color03 } ---> BACKCOLOR {128,126,255} 
 
 ***             Language Sample   

 ***  BoxShadow(110, 120, 200, 058 ,"01" ,"02", 128 ,126 , 255 ) 

*---------------------------------------------------------------------------------------------*

 Local clavel01 := ALLTRIM("Label_") + ALLTRIM(Nom)
 Local clavel02 := ALLTRIM("Label_") + ALLTRIM(Num)
 Local Colorx := { Color01 , Color02 , Color03 }  

  DEFINE label &clavel01        
         ROW   CurRow
         COL   CurCol  
         WIDTH  LastWidth 
         HEIGHT LastHeight 
         VALUE ""
         FONTNAME "Ms Sans Serif"
         FONTSIZE 11
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE .T.
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR {000,000,000}  
         FONTCOLOR Nil
    END LABEL

    DEFINE label &clavel02   
         ROW    CurRow  - 6
         COL    CurCol  - 5
         WIDTH  LastWidth 
         HEIGHT LastHeight 
         VALUE ""
         FONTNAME "Ms Sans Serif"
         FONTSIZE 11
         TOOLTIP ""
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE .T.
         TRANSPARENT .F.
         ACTION Nil
         AUTOSIZE .F.
         BACKCOLOR ColorX 
         FONTCOLOR Nil
         BORDER .T.
         CLIENTEDGE .T.
    END LABEL

Return

*-------------------------------------------------------------------------------------------*
Func LetterShadow(CurLRow, CurLCol,NomL, NumL , Valu ,SizeL ,ColorL01 , ColorL02, ColorL03 )
*-------------------------------------------------------------------------------------------*
 ***                       Normal Sintax 

 ***        @ 118,500 LABEL Label_55 VALUE "Hello World ..." AUTOSIZE ;
 ***                  FONT "Arial" SIZE 25 BOLD ITALIC ;
 ***                  FONTCOLOR BLACK TRANSPARENT
 ***        @ 116,499 LABEL Label_66 VALUE "Hello World ..." AUTOSIZE ;
 ***                  FONT "Arial" SIZE 25 BOLD ITALIC ;
 ***                  FONTCOLOR {206,223,239}  TRANSPARENT  

*------------------------- New Sintax ---------------------------------------------------------*

 ***           Sample Syntax Parameters LetterShadow  ------->  (Letras con Sombra) (Shaded Letter)

 ***  Row -------->  CurLRow  = 118 
 ***  Col -------->  CurLCol  = 500
 ***  Label name ->  Lclavel01 := ALLTRIM("Label_") + ALLTRIM(NomL) = Label_55
 ***  Label name ->  Lclavel02 := ALLTRIM("Label_") + ALLTRIM(NumL) = Label_66 
 ***  Valu ------->  Valuex    := ALLTRIM(Valu)  -----> Value "Hola Mundo ..." 
 ***  SizeL  ----->  Sizex     :=  SizeL  ------------> FONTSIZE 25 
 ***  LColorx := { ColorL01 , ColorL02 , ColoLr03 } --> FONTCOLOR {206,223,239} 
               
 ***              Language Sample  

 ***  LetterShadow (118, 500 ,"55" ,"66","Hello World ...",25, 206,223,239 ) 

*---------------------------------------------------------------------------------------------*

 Local Lclavel01 :=   ALLTRIM("Label_") + ALLTRIM(NomL)
 Local Lclavel02 :=   ALLTRIM("Label_") + ALLTRIM(NumL)
 Local Valuex    :=   ALLTRIM(Valu)                        
 Local Sizex     :=   SizeL
 Local LColorx   := { ColorL01 , ColorL02 , ColorL03 }  

  DEFINE label &Lclavel01        
         ROW   CurLRow
         COL   CurLCol  
         VALUE valuex
         FONTNAME "Arial"
         FONTSIZE Sizex 
         TOOLTIP ""
         FONTBOLD .T.
         FONTITALIC .T.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE .T.
         TRANSPARENT .T.
         ACTION Nil
         AUTOSIZE .T.
         BACKCOLOR Nil     
         FONTCOLOR BLACK
    END LABEL

    DEFINE label &Lclavel02   
         ROW  CurLRow  - 2
         COL  CurLCol  - 2
         VALUE valuex
         FONTNAME "Arial"
         FONTSIZE  Sizex  
         TOOLTIP ""
         FONTBOLD .T.
         FONTITALIC .T.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         HELPID Nil
         VISIBLE .T.
         TRANSPARENT .T.
         ACTION Nil
         AUTOSIZE .T.
         BACKCOLOR Nil  
         FONTCOLOR LColorX       
    END LABEL

Return       

*-----------------------------------------------------------------------------------------------------------------------------------------------*
Func  LabelBox(CurZRow,CurZCol,LasZWidth,LasZHeight,NomZ,ValuZ,SizeZ,bOLdx,iTAlx,ColorZ01,ColorZ02,ColorZ03,ColorZ04,ColorZ05,ColorZ06 )
*------------------------------------------------------------------------------------------------------------------------------------------------*
 ***                       Normal Sintax 

 ***      @ 118,040 LABEL Label_55 VALUE 'Hello World'  ;    
 ***                FONT "Arial" SIZE 23 BOLD ITALIC  BACKCOLOR  {155,197,229}  FONTCOLOR {206,223,239}  ;
 ***                WIDTH 100 HEIGHT 30 

 ***      @ 382,372 LABEL Label_55 VALUE SUBSTR(DTOC(DATE()),7,4) CENTERALIGN ;
 ***                FONT "Arial" SIZE 50 BOLD ITALIC BACKCOLOR {000,000,000} FONTCOLOR {255,255,255}   ;
 ***                WIDTH 200 HEIGHT 90


*------------------------- New Sintax ---------------------------------------------------------*

 ***           Sample Syntax Parameters LabelBox  -----> ( Simplificar el Label Normal) (Simplify Normal Label)  

 ***  Row -------->  CurZRow         = 118 
 ***  Col -------->  CurZCol         = 040
 ***  WIDTH ------>  LasZWidth       = 200
 ***  HEIGHT ----->  LasZHeight      = 058
 ***  Label name ->  LclaveZ01      := ALLTRIM("Label_") + ALLTRIM(NomZ) = Label_55
 ***  ValueZA ---->  ValuZ          := ALLTRIM(ValuZ)  -----> Value "Hola Mundo ..." 
 ***  SizeZA  ---->  SizeZ          := SizeZ ---------------> FONTSIZE 15 
 ***  bOLdx ------>  .F. OR .T.  
 ***  iTAlx ------>  .F. OR .T.  
 ***  LColorZa := { ColorZ01 , ColorZ02 , ColoLZ03 } --> BACKCOLOR {155,197,229} 
 ***  LColorZb := { ColorZ04 , ColorZ05 , ColoLZ06 } --> FONTCOLOR {206,223,239}               
 
 ***              Language Sample  

 ***  LabelBox(118, 040, 200, 058 ,"55","Hello World",15 , 155,197,229 , 206,223,239 ) <---"Hello World.." or ALLTRIM("Hello World..")
 ***  LabelBox(118, 140, 200, 058 ,"55",DTOC(DATE()) ,15 , 155,197,229 , 206,223,239 ) <--- DTOC(DATE())
 ***  LabelBox(600, 338, 210, 028 ,"55",   ,12 ,.T.,.T., 000,000,000 , 255,255,255 )   <----Without Value  <-----Sin Value
 ***  LabelBox(118, 140, 200, 058 ,"55",DTOC(DATE()),15 ,    ,   ,    ,    ,   ,    )  <--- Without Colour <-----Sin Color
 ***  LabelBox(118, 140, 200, 058 ,"55","Hello World",15 ,.T.,.T.,   ,    ,   ,   ,   ,   ) <--- FONTBOLD .T. FONTITALIC .T.

*---------------------------------------------------------------------------------------------*

 Local LclaveZ01  :=   ALLTRIM("Label_") + ALLTRIM(NomZ)
 Local ValueZA    :=   ValuZ                              
 Local SizeZA     :=   SizeZ
 Local FbOLD      :=   bOLdx
 Local FiTALIC    :=   iTAlx 
 Local LColorZa   := { ColorZ01 , ColorZ02 , ColorZ03 }  
 Local LColorZb   := { ColorZ04 , ColorZ05 , ColorZ06 }  
   
                                         *---  SAMPLE ------*
     DEFINE label &LclaveZ01       //  <---------  Label_55   
          ROW   CurZRow            //  <---------  118
          COL   CurZCol            //  <---------  040              
          WIDTH  LasZWidth         //  <---------  200 
          HEIGHT LasZHeight        //  <---------  058  
          VALUE ValueZA            
          FONTNAME "Arial"         
          FONTSIZE SizeZA          //  <---------  15 
          TOOLTIP ""
          ALIGNMENT CENTER          // <--------- ( CENTER,LEFT,RIGHT )( CENTERALIGN ,RIGHTALIGN) 
          FONTBOLD FbOLD           //  <---------  .F. OR .T.
          FONTITALIC FiTALIC       //  <---------  .F. OR .T.              
          FONTUNDERLINE .F.
          FONTSTRIKEOUT .F.
          HELPID Nil
          VISIBLE .T.
          TRANSPARENT .T.
          ACTION Nil
          AUTOSIZE .T.
          BACKCOLOR  LColorZa       //  <--------- {155,197,229} 
          FONTCOLOR  LColorZb       //  <--------- {206,223,239}  
    END LABEL

Return
        





