* Function Original de brunellopulix (brunellopulix@yahoo.it)

# include 'hbclass.ch'
# include 'common.ch'
*
FUNCTION MakeCell(cLabel,cSize,cAlignment,cBorder,cFormat,FieldNum,cPage_Day,cFont,cColor)
   LOCAL oCell
   *
   oCell           :=      QCell():New()
   oCell:Label     :=      cLabel
   oCell:Caption   :=      cLabel
   IF !IsNil(cSize)
      oCell:Size   :=      cSize
   ENDIF
   IF !IsNil(cAlignment)
      IF 'c' $ Lower(cAlignment)
         oCell:Alignment   :=      'c'
      ELSEIF 'r' $ Lower(cAlignment)
         oCell:Alignment   :=      'r'
      ELSEIF 'j' $ Lower(cAlignment)
         oCell:Alignment   :=      'j'
      ELSE
         oCell:Alignment   :=      'l'
      ENDIF
      IF 't' $ Lower(cAlignment)
         oCell:VertTop      := TRUE
      ELSEIF "w" $ Lower(cAlignment)
         oCell:VertCenter   := TRUE
      ELSE
         oCell:VertBot          := TRUE
      ENDIF
   ENDIF
   IF !IsNil(cBorder)
      oCell:Border      :=      Upper(cBorder)
   ENDIF
   IF !IsNil(cFormat)
      IF "b" $ Lower(cFormat)
         oCell:bold              :=      TRUE
      ENDIF
      IF "u" $ Lower(cFormat)
         oCell:Underline         :=      TRUE
      ENDIF
      IF "i" $ Lower(cFormat)
         oCell:Italic            :=      TRUE
      ENDIF
   ENDIF
   IF !IsNil(FieldNum)
      oCell:FieldNum        :=      FieldNum
   ENDIF
   IF !IsNil(cPage_Day) .and. !Empty(cPage_Day)
      IF "p" $ Lower(cPage_Day)
         oCell:Page       :=      TRUE
      ENDIF
      IF "d" $ Lower(cPage_Day)
         oCell:day     :=      TRUE
      ENDIF
   ENDIF
   IF !IsNil(cFont) .and. !Empty(cFont)
      oCell:Font       :=    cFont
   ENDIF
   IF !IsNil(cColor) .and. !Empty(cColor)
      oCell:color       :=    cColor
   ENDIF
   *
RETURN oCell

*
CLASS QCell
DATA Label
DATA Caption
DATA Size
DATA Font
DATA Border
DATA Bold
DATA Underline
DATA Italic
DATA Alignment
DATA FieldNum
DATA Page
DATA Day
DATA Color
DATA VertTop
DATA VertCenter
DATA VertBot
METHOD New()
EndClass
METHOD New() CLASS QCell
SELF:Label      :=  ""
SELF:Caption    :=  ""
SELF:Size       :=  "20"
SELF:Font       :=  "0"
SELF:Border     :=  ""
SELF:Bold       :=  .F.
SELF:Underline  :=  .F.
SELF:Italic     :=  .F.
SELF:Alignment  :=  "l"
SELF:FieldNum   :=  0
SELF:Page       :=  .F.
SELF:Day        :=  .F.
SELF:Color      :=  '0'
SELF:VertBot    :=  .T.
SELF:VertTop    :=  .F.
SELF:VertCenter :=  .F.
RETURN SELF
